<ui:composition xmlns:g="http://www.ihe.net/gazelle" xmlns:a4j="http://richfaces.org/a4j"
                xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:gzl="http://java.sun.com/jsf/composite/gazelle-tags"
                xmlns:h="http://java.sun.com/jsf/html" xmlns:f="http://java.sun.com/jsf/core"
                xmlns="http://www.w3.org/1999/xhtml">

    <ui:decorate template="#{form_template == null ? '/layout/form/_form_field_horizontal_4-8.xhtml' : form_template}">
        <ui:param name="id" value="#{filterId}#{idSuffix}Select"/>
        <ui:define name="label">
            <h:outputText value="#{filterName}"/>
        </ui:define>
        <span class="gzl-never-wrap">

            <a4j:jsFunction name="update#{filterId}#{idSuffix}"
                            render="#{filterId}#{idSuffix}Select"
                            immediate="true" ajaxSingle="true"
                            execute="#{filterId}#{idSuffix}Select"
                            oncomplete="openSelectBox.filterId = '.#{filterId}#{idSuffix}In';"
                            actionListener="#{filter.setDisplay(filterId)}"/>

            <gzl:div id="#{filterId}#{idSuffix}Select" styleClass="gzl-filter-control">
                <h:panelGroup rendered="#{!filter.isDisplay(filterId)}">
                    <div onclick="update#{filterId}#{idSuffix}();"
                         class="chosen-container chosen-container-single" style="width: 90%;">
                        <a class="chosen-single" tabindex="-1">
                            <h:panelGroup
                                    rendered="#{filter.filterValues[filterId] == null}">
                                <span>#{messages['gazelle.common.button.ShowAll']}</span>
                            </h:panelGroup>
                            <h:panelGroup
                                    rendered="#{filter.filterValues[filterId] != null}">
                                <span>#{filter.stringValues[filterId]}</span>
                            </h:panelGroup>
                            <div>
                                <b/>
                            </div>
                        </a>
                    </div>
                    <h:panelGroup
                            rendered="#{filter.filterValues[filterId] == null}">
                        <a>
                            <span class="gzl-icon-times"/>
                        </a>
                    </h:panelGroup>
                    <h:panelGroup
                            rendered="#{filter.filterValues[filterId] != null}">
                        <a4j:commandLink event="click" actionListener="#{filter.resetField(filterId)}"
                                         render="#{filterForm}" execute="@this">
                            <span class="gzl-icon-times"/>
                        </a4j:commandLink>
                    </h:panelGroup>
                </h:panelGroup>

                <h:panelGroup rendered="#{filter.isDisplay(filterId)}">

                    <h:selectOneMenu id="#{filterId}#{idSuffix}In"
                                     styleClass="form-control gzl-select-text #{filterId}#{idSuffix}In"
                                     style="width: 90%;display: initial;"
                                     value="#{filter.filterValues[filterId]}"
                                     converter="#{filter.getConverter(filterId)}">
                        <f:selectItem itemLabel="#{messages['gazelle.common.button.ShowAll']}" itemValue="#{null}"/>
                        <f:selectItems value="#{filter.possibleValues[filterId]}" var="selectedValue"
                                       itemLabel="#{filter.formatters[filterId].format(selectedValue)}" itemValue="#{selectedValue}"/>
                        <a4j:ajax event="change" render="#{filterForm}" execute="@this"/>

                    </h:selectOneMenu>

                    <a4j:commandLink event="click" actionListener="#{filter.resetField(filterId)}"
                                     render="#{filterForm}" execute="@this">
                        <span class="gzl-icon-times"/>
                    </a4j:commandLink>

                    <h:panelGroup rendered="#{filterSuggestBean.supportsLink(filter, filterId)}">
                        <span title="Details">
                            <g:imagelink value="#{filter.getRealFilterValue(filterId)}"
                                         fontIcon="gzl-icon-info-circle" target="_blank"/>
                        </span>
                    </h:panelGroup>
                </h:panelGroup>
            </gzl:div>
        </span>
    </ui:decorate>
</ui:composition>
